package data.scripts.wyv;

import java.util.List;

import com.fs.starfarer.api.BaseModPlugin;
import com.fs.starfarer.api.Global;
import com.fs.starfarer.api.campaign.SectorAPI;
import com.fs.starfarer.api.campaign.econ.EconomyAPI;
import com.fs.starfarer.api.campaign.econ.MarketAPI;
import com.fs.starfarer.api.impl.campaign.econ.impl.PlanetaryShield;
import org.json.JSONObject;

public class PSModPlugin extends BaseModPlugin {
	public static boolean revertToVanilla = false;
	@Override
	public void onApplicationLoad() throws Exception {
		JSONObject settings = Global.getSettings().loadJSON( "wyv_ps_settings.json" );
		revertToVanilla = settings.getBoolean( "revertToVanillaShieldBehavior" );
	}

	@Override
	public void onEnabled( boolean wasEnabledBefore ) {
		SectorAPI sector = Global.getSector();
		if( sector != null ) {
			EconomyAPI econ = sector.getEconomy();
			if( econ != null ) {
				List markets = econ.getMarketsCopy();
				for( int i = 0; i < markets.size(); i++ ) {
					MarketAPI market = (MarketAPI)markets.get( i );
					if( market != null ) {
						Object shieldObj = market.getIndustry( "planetaryshield" );
						if( shieldObj != null && shieldObj instanceof com.fs.starfarer.api.impl.campaign.econ.impl.PlanetaryShield ) {
							com.fs.starfarer.api.impl.campaign.econ.impl.PlanetaryShield shield = (com.fs.starfarer.api.impl.campaign.econ.impl.PlanetaryShield)shieldObj;
							float disrupted = shield.getDisruptedDays();
							float build = shield.getBuildOrUpgradeProgress();
							market = econ.getMarket( market.getId() );
							market.removeIndustry( "planetaryshield", null, false );
							market.addIndustry( "planetaryshield" );
							data.scripts.wyv.PlanetaryShield newShield = (data.scripts.wyv.PlanetaryShield)market.getIndustry( "planetaryshield" );
							if( build > 0 ) newShield.setNewBuild( build );
							if( disrupted > 0 ) newShield.setDisrupted( disrupted );
						}
						econ.getMarket( market.getId() ).reapplyIndustries();
					}
				}
			}
		}
	}
}
